#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <iostream>

using namespace std;

int vec_smaller (int length, int* vec1, int* vec2)
// computes whether a vector is smaller than
// another one in the lexicographic order
  {
	int l;
	int smaller;

	smaller = 0;
  l = 0;
  while (l < length)
	  {
		if (vec1[l] < vec2[l])
		  {
			smaller = 1;
			break;
		  }
		else	
		  {
			if (vec1[l] > vec2[l])
				break;
			else
				l++;
			}
		}

	return smaller;
	}

void random_question (int c, int p, int seed, int* question)
// computes a random question
  {
	int i,j,l;
	int ihilf;
	int counter;
	int* boolvec;

  boolvec = (int*) malloc(sizeof(int) * c);

  for (l=0; l<c; l++)
	  boolvec[l] = 0;

	srand (seed);
	i = 0;
	while (i < p)
		{
		ihilf = rand() % (c-i);
		j = 0;
		counter = 0;
		while (1)
			{
			if (boolvec[j] == 0)
				{
				if (counter == ihilf)
					{
					boolvec[j] = 1;
					question[i] = j;
					break;
					}
				counter++;
				}
			j++;
			}
		i++;
		}

	free (boolvec);
	return;
	}

int fak (int n)
//  computes the factorial of a natural 
  {
	int i;
  int res = 1;

  for (i=0; i<n; i++)
    res *= (i+1);

	return res;
	}


int numvec (int length, int *vec1, int *vec2)
//  computes in how many components two 
//  vectors coincide
  {
	int i;
	int numeq=0; 

  for (i=0; i<length; i++)
    {
		if (vec1[i] == vec2[i])
		  numeq++;
		}

	return numeq;
	}

int eqvec (int length, int *vec)
//  computes whether a vector is equal in at least
//  two components 
  {
	int s,t;
  int equal = 0;

	for (s=0; s<length; s++)
		for (t=s+1; t<length; t++)
			{
			if (vec[s] == vec[t])
				{
				equal = 1;
				return equal;
				}
			}

	return equal;
	}

bool strategy_check (int c, int fixedpc, int output, int p, int questions, int **strategy)
// checks the feasibility of a strategy 	
	{
	int i,j,l,r,s,t;
	int ihilf;
	bool optstrat;
	bool fbool;
	int first;
	int second;
	int nullpeg;
	int numsec;
	int numsec2;
  int counter;
  int groupzaehl;
  int gcounter;
  int kcounter;
  int ncounter;
  int nextgroup;
  int weiter;
	int mins;
	int mint;
	int diffvalue;
	int mindiffvalue;

	int *boolvec;
  int *fixedcvec;
  int *fixedpvec;
  int *groupanswervec;
	int *groupvec;
	int *hilfvec;
	int *nullvec;

	int **answermat;
	int **pmat;
  int **grouppmat;

	first = 1;
  groupzaehl = 0;
  weiter = 1;

	ihilf = 1;
	for (s=0; s<p; s++)
		ihilf *= (c-s);
	numsec = ihilf;

  boolvec = (int*) malloc(sizeof(int) * numsec);
  fixedcvec = (int*) malloc(sizeof(int) * c);
  fixedpvec = (int*) malloc(sizeof(int) * p);
  groupanswervec = (int*) malloc(sizeof(int) * numsec);
  groupvec = (int*) malloc(sizeof(int) * numsec);
  hilfvec = (int*) malloc(sizeof(int) * numsec);
  nullvec = (int*) malloc(sizeof(int) * numsec);

  answermat = (int**) malloc(sizeof(int*) * numsec);
  grouppmat = (int**) malloc(sizeof(int*) * numsec);
  pmat = (int**) malloc(sizeof(int*) * numsec);

  for (s=0; s<numsec; s++)
	  answermat[s] = (int*) malloc(sizeof(int) * questions);

  for (s=0; s<numsec; s++)
	  grouppmat[s] = (int*) malloc(sizeof(int) * p);

  for (s=0; s<numsec; s++)
	  pmat[s] = (int*) malloc(sizeof(int) * p);

	for (s=0; s<numsec; s++)
    groupvec[s] = 0;

	for (s=0; s<numsec; s++)
    nullvec[s] = 1;

  optstrat = 1;

	counter = 0;
	numsec2 = (int) floor(pow(c,p)+0.5);

	for (s=0; s<numsec2; s++)
		{
		for (j=0; j<p; j++)
			hilfvec[j] = 0;

		ihilf = s;
		j=p-1;
		while (j>=0)
			{
			hilfvec[j] = ihilf % c;
			ihilf /= c;
			j--;
			}

		if (eqvec(p,hilfvec))
			continue;

		for (j=0; j<p; j++)
			pmat[counter][j] = hilfvec[j];

		for (i=0; i<questions; i++)
			answermat[counter][i] = numvec(p, strategy[i], pmat[counter]);

    counter++;
		}

	for (s=0; s<numsec; s++)
    boolvec[s] = 0;

  gcounter = 0;

	for (s=0; s<numsec; s++)
    {
		if (output)
      {
			if (boolvec[s] == 1)
				continue;

			groupanswervec[groupzaehl] = s;
			boolvec[s] = 1;

			for (j=0; j<p; j++)
				grouppmat[gcounter][j] = pmat[s][j];
			gcounter++;

			groupvec[groupzaehl] = 1;
			}


		for (t=s+1; t<numsec; t++)
      {
			if (output)
			  {
				if (boolvec[t] == 1)
					continue;
        }

			if (numvec(questions,answermat[s],answermat[t]) == questions)
				{
				diffvalue = p-numvec(p,pmat[s],pmat[t]);
				if (first == 1)
					{
					mins = s;
					mint = t;
					mindiffvalue = diffvalue;
					}
        else
				  {
					if (diffvalue < mindiffvalue)
						{
						mins = s;
						mint = t;
						mindiffvalue = diffvalue;
					  }
					}

				optstrat = 0;

        if (output)
				  {
					groupvec[groupzaehl]++;
					boolvec[t] = 1;
					
					for (j=0; j<p; j++)
						grouppmat[gcounter][j] = pmat[t][j];
					gcounter++;
				  }
			  }
			}

		if (output)
			groupzaehl++;
    }

  if (output)
	  {
		gcounter = 0;
		kcounter = 0;
		ncounter = 0;

		if (fixedpc == 1)
			{
			for (l=0; l<c; l++)
				fixedcvec[l] = 1;
			for (j=0; j<p; j++)
				fixedpvec[j] = 1;
			}

		for (s=0; s<groupzaehl; s++)
			{
			if (groupvec[s] > 1)
				kcounter++;
				  
			  
			if (groupvec[s] > 1)
				{
				if (weiter == 1)
				  {
					cout << "A: ";
					for (t=0; t<questions; t++)
						cout << answermat[groupanswervec[s]][t] << " ";
					cout << endl;	
				  }
        }

			if (fixedpc == 1)
				{
				for (t=0; t<groupvec[s]; t++)
					for (r=t+1; r<groupvec[s]; r++)
						{
						for (j=0; j<p; j++)
							{
							for (l=0; l<c; l++)
								{
								if (grouppmat[gcounter+t][j] == l 
										&& grouppmat[gcounter+r][j] != l)
									{
									fixedcvec[l] = 0; 
									fixedpvec[j] = 0; 
								  }
								}
							}
						}
				}		

			if (groupvec[s] > 1)
				{
				for (t=0; t<groupvec[s]; t++)
					{
					if (weiter == 1)
					  {
						if (groupvec[s] > 1)  
							{
							if (t+1 < 10)
								cout << " " << t+1 << ": ";
							else
								cout << t+1 << ": ";

							for (j=0; j<p; j++)
								cout << grouppmat[gcounter][j] << " ";
							cout << endl;
						  }
					  }
					gcounter++;
					}
				if (weiter == 1)
					if (groupvec[s] > 1) 
						cout << endl;	
				weiter = 0;
				}
			else	
				gcounter++;
			}

		if (output)
			cout << "optstrat = " << optstrat << endl;
   
		if (fixedpc == 1)
			{
			fbool = 0;
			if (optstrat == 0)
			  {
				cout << endl;
				cout << "Solved colors: ";
				for (l=0; l<c; l++)
					{
					if (fixedcvec[l] == 1)
						{
						if (fbool == 0)
							cout << endl;
						cout << l << " ";
						fbool = 1;
						}
					}
				if (fbool == 0)
					cout << "None solved.";
				cout << endl;

				fbool = 0;
				cout << "Solved pegs: ";
				for (j=0; j<p; j++)
					{
					if (fixedpvec[j] == 1)
						{
						if (fbool == 0)
							cout << endl;
						cout << j << " ";
						fbool = 1;
						}
					}
				if (fbool == 0)
					cout << "None solved.";
				cout << endl;
			  }
			}
    }

  free (boolvec);
  free (fixedcvec);
  free (fixedpvec);
  free (groupanswervec);
  free (groupvec);
  free (hilfvec);
  free (nullvec);

  for (s=0; s<numsec; s++)
	   free (answermat[s]);
	free (answermat);

	for (s=0; s<numsec; s++)
		free (grouppmat[s]);
	free (grouppmat);

  for (s=0; s<numsec; s++)
	   free (pmat[s]);
	free (pmat);

	return optstrat;
  }

int main (int argc, char **argv)
  {
	int i,j,l;
	int s,t;
	int start;
	int anzstrat;
	int c;
	int filexist;
	int fixedpc;
	int optstrat;
	int output;
	int p;
	int soutput;
	int seed;
	int successes;
	int questions;
	int version;
	int* vec1;
	int* vec2;
	int* vec3;
	int* vec4;
	int* vec5;
	int* vec6;
	int* vec7;
	int* vec8;
	int **strategy;
	char* ep;
  char* filename;
  FILE *fname;
  char* y;

	anzstrat = 1;
	c = 3;
	filexist = 0;
	fixedpc = 1;
	output = 1;
	soutput = 0;
	p = 3;
	seed = 0;
	successes = 0;
	questions = 3;
  version = 0;

  filename = (char*) malloc(sizeof(char) * 100);

  for (start = 1; start < argc; start++)
		{    
		if (*argv[start] == '-') 
			{    
			char *ep; 
			char *sc = argv[start] + 1; 
			
			while (*sc)
				{
				switch (*sc++)
				  {
					case 'a': 
					  anzstrat = strtoul(sc, &ep, 10); 
					  if (ep > sc)
							sc = ep; 
					break;
					case 'c': 
					  c = strtoul(sc, &ep, 10); 
					  if (ep > sc)
							sc = ep; 
					break;
					case 'p': 
					  p = strtoul(sc, &ep, 10); 
					  if (ep > sc)
							sc = ep; 
					break;
					case 'q': 
					  questions = strtoul(sc, &ep, 10); 
					  if (ep > sc)
							sc = ep; 
					break;
					case 'r': 
					  soutput = 1;
					break;
					case 's': 
					  seed = strtoul(sc, &ep, 10); 
					  if (ep > sc)
							sc = ep; 
					break;
					case 'v': 
					  version = strtoul(sc, &ep, 10); 
					  if (ep > sc)
							sc = ep; 
					break;
          }
				}
			}
		else
			{
      filexist = 1;
			strcpy (filename,argv[start]);
		  }
		}	


	if (filexist == 1)
	  {
		if (fname = fopen (filename,"r"))
			{
			}
		else
			{
			cout << "Error1" << endl;
			cout << "File ``" << filename << "`` kann nicht geoeffnet werden!" << endl;
			exit(1);
			}
		}	

	cout << "colors=" << c << endl;
	cout << "pegs=" << p << endl;
	if (seed != 0)
		cout << "seed=" << seed << endl;
	cout << "questions=" << questions << endl;

	if (p > c)
		{
		cout << "Error2" << endl;
		cout << "p = " << p << " is larger tha " << "c = " << c << " in AB Game." << endl;
		exit(1);
		}

  if ( (filexist ==1 || version != 0) && anzstrat != 1)
	  {
		cout << "Error3=" << endl;
		cout << "Several random strategies" 
		     << "are not available in thie variant" << endl;
		}

  vec1 = (int*) malloc(sizeof(int) * p);
  vec2 = (int*) malloc(sizeof(int) * p);
  vec3 = (int*) malloc(sizeof(int) * p);
  vec4 = (int*) malloc(sizeof(int) * p);
  vec5 = (int*) malloc(sizeof(int) * p);
  vec6 = (int*) malloc(sizeof(int) * p);
  vec7 = (int*) malloc(sizeof(int) * p);
  vec8 = (int*) malloc(sizeof(int) * p);
  strategy = (int**) malloc(sizeof(int*) * questions);

  for (i=0; i<questions; i++)
	  strategy[i] = (int*) malloc(sizeof(int) * p);

	int s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11,s12,s13,s14,s15,s16,s17,s18,s19,s20;
	int equal;
	int ges;
  int lbound,ubound;


	for (l=0; l<anzstrat; l++)
		{
		switch (version)
			{
			case 0:
				if (filexist == 0)
					{
					if (seed == 0)
						{
						cout << "Error4" << endl;
						cout << "Strategy file is missing." << endl;
						exit(1);
						}
					else 
						{
						for (i=0; i<questions; i++)
							random_question (c,p,seed+l+1000*i,strategy[i]);
						}
					}
				else
					{
					for (i=0; i<questions; i++)
						{
						for (j=0; j<p; j++)
							{
							fscanf (fname,"%d \n", &strategy[i][j]);
							if (strategy[i][j] > c-1 || strategy[i][j] < 0)
								{
								cout << "Error5" << endl;
								cout << "In entry (" << i << ", " << j 
								     << ") there is the entry " 
										 << strategy[i][j] << "." << endl; 
								exit(1);
								}
							}
						}	
					fclose (fname);
					}	

				for (i=0; i<questions; i++)
					{
					equal = eqvec (p,strategy[i]);
					if (equal == 1)
						{
						cout << "Error6" << endl;
						cout << "In the AB-Game there" 
								 << "are two equal entries in the " 
								 << i+1 << "-th question " << endl;
						exit(1);
						}
					}

				if (anzstrat == 1 && soutput)
					{
					cout << "Strategy:" << endl;
					for (i=0; i<questions; i++)
						{
						for (j=0; j<p; j++)
							cout << strategy[i][j] << " ";
						
						cout << endl;
						}
					}


				if (anzstrat != 1)
					{
					fixedpc = 0;
					output = 0;
					}

				optstrat = strategy_check (c, fixedpc, output, p, questions, strategy);
				 
				if (optstrat == 1)
					successes++;

        if (anzstrat != 1 && soutput && optstrat == 1)
				  {
					cout << "Strategy:" << endl;
					for (i=0; i<questions; i++)
						{
						for (j=0; j<p; j++)
							cout << strategy[i][j] << " ";
						
						cout << endl;
						}
					}

				if (version != 0 && optstrat == true)
					{
					cout << "Error7" << endl;
					cout << "Strategy is already feasible." << endl;
					exit(1);
					}
			break;
			case 1:	
			  // p=2, c=4, questions=3
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				vec1[0] = 0;
				vec1[1] = 1;
				lbound = 0;
				ubound = 3;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						{
						vec2[0] = s1;
						vec2[1] = s2;
						if (eqvec(p,vec2))
							continue;
						if (vec_smaller (p,vec1,vec2) == 0)	
							continue;

						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
								{
								vec3[0] = s3;
								vec3[1] = s4;
								if (eqvec(p,vec3))
									continue;
								if (vec_smaller (p,vec2,vec3) == 0)	
									continue;
								strategy[1][0] = s1;
								strategy[1][1] = s2;
								strategy[2][0] = s3;
								strategy[2][1] = s4;
								optstrat = strategy_check (c, 0, 
																					 0, p, questions, strategy);
								if (optstrat == true)
									{
									cout << "s1=" << s1 << endl;
									cout << "s2=" << s2 << endl;
									cout << "s3=" << s3 << endl;
									cout << "s4=" << s4 << endl;
									exit(1);
									}
								}
						}
				cout << "No solution" << endl;
			break;
			case 2:
				// p=2, c=5, questions=4
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				vec1[0] = 0;
				vec1[1] = 1;
				lbound = 0;
				ubound = 4;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						{
						vec2[0] = s1;
						vec2[1] = s2;
						if (eqvec(p,vec2))
							continue;
						if (vec_smaller (p,vec1,vec2) == 0)	
							continue;
						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
									{
									vec3[0] = s3;
									vec3[1] = s4;
									if (eqvec(p,vec3))
										continue;
									if (vec_smaller (p,vec2,vec3) == 0)	
										continue;
									for (s5=lbound; s5<=ubound; s5++)
										for (s6=lbound; s6<=ubound; s6++)
												{
												vec4[0] = s5;
												vec4[1] = s6;
												if (eqvec(p,vec4))
													continue;
												if (vec_smaller (p,vec3,vec4) == 0)	
													continue;
												strategy[1][0] = s1;
												strategy[1][1] = s2;
												strategy[2][0] = s3;
												strategy[2][1] = s4;
												strategy[3][0] = s5;
												strategy[3][1] = s6;
												optstrat = strategy_check (c, 0, 
																									 0, p, questions, strategy);
												if (optstrat == true)
													{
													cout << "s1=" << s1 << endl;
													cout << "s2=" << s2 << endl;
													cout << "s3=" << s3 << endl;
													cout << "s4=" << s4 << endl;
													cout << "s5=" << s5 << endl;
													cout << "s6=" << s6 << endl;
													exit(1);
													}

												}
									}
						}
				cout << "No solution" << endl;
			break;
			case 3:
				// p=2, c=6, questions=5
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				vec1[0] = 0;
				vec1[1] = 1;
				lbound = 0;
				ubound = 5;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						{
						vec2[0] = s1;
						vec2[1] = s2;
						if (eqvec(p,vec2))
							continue;
						if (vec_smaller (p,vec1,vec2) == 0)	
							continue;
						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
								{
								vec3[0] = s3;
								vec3[1] = s4;
								if (eqvec(p,vec3))
									continue;
								if (vec_smaller (p,vec2,vec3) == 0)	
									continue;
								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										{
										vec4[0] = s5;
										vec4[1] = s6;
										if (eqvec(p,vec4))
											continue;
										if (vec_smaller (p,vec3,vec4) == 0)	
											continue;
										for (s7=lbound; s7<=ubound; s7++)
											for (s8=lbound; s8<=ubound; s8++)
												{
												vec5[0] = s7;
												vec5[1] = s8;
												if (eqvec(p,vec5))
													continue;
												if (vec_smaller (p,vec4,vec5) == 0)	
													continue;
												strategy[1][0] = s1;
												strategy[1][1] = s2;
												strategy[2][0] = s3;
												strategy[2][1] = s4;
												strategy[3][0] = s5;
												strategy[3][1] = s6;
												strategy[4][0] = s7;
												strategy[4][1] = s8;
												optstrat = strategy_check (c, 0, 
																									 0, p, questions, strategy);
												if (optstrat == true)
													{
													cout << "s1=" << s1 << endl;
													cout << "s2=" << s2 << endl;
													cout << "s3=" << s3 << endl;
													cout << "s4=" << s4 << endl;
													cout << "s5=" << s5 << endl;
													cout << "s6=" << s6 << endl;
													cout << "s7=" << s7 << endl;
													cout << "s8=" << s8 << endl;
													exit(1);
													}
												}
										}
							}
						}
				cout << "No solution" << endl;
			break;
			case 4:
				// p=2, c=7, questions=7
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				vec1[0] = 0;
				vec1[1] = 1;
				lbound = 0;
				ubound = 6;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						{
						vec2[0] = s1;
						vec2[1] = s2;
						if (eqvec(p,vec2))
							continue;
						if (vec_smaller (p,vec1,vec2) == 0)	
							continue;
						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
								{
								vec3[0] = s3;
								vec3[1] = s4;
								if (eqvec(p,vec3))
									continue;
								if (vec_smaller (p,vec2,vec3) == 0)	
									continue;
								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										{
										vec4[0] = s5;
										vec4[1] = s6;
										if (eqvec(p,vec4))
											continue;
										if (vec_smaller (p,vec3,vec4) == 0)	
											continue;
										for (s7=lbound; s7<=ubound; s7++)
											for (s8=lbound; s8<=ubound; s8++)
												{
												vec5[0] = s7;
												vec5[1] = s8;
												if (eqvec(p,vec5))
													continue;
												if (vec_smaller (p,vec4,vec5) == 0)	
													continue;
												for (s9=lbound; s9<=ubound; s9++)
													for (s10=lbound; s10<=ubound; s10++)
														{
														vec6[0] = s9;
														vec6[1] = s10;
														if (eqvec(p,vec6))
															continue;
														if (vec_smaller (p,vec5,vec6) == 0)	
															continue;
														for (s11=lbound; s11<=ubound; s11++)
															for (s12=lbound; s12<=ubound; s12++)
																{
																vec7[0] = s11;
																vec7[1] = s12;
																if (eqvec(p,vec7))
																	continue;
																if (vec_smaller (p,vec6,vec7) == 0)	
																	continue;
																strategy[1][0] = s1;
																strategy[1][1] = s2;
																strategy[2][0] = s3;
																strategy[2][1] = s4;
																strategy[3][0] = s5;
																strategy[3][1] = s6;
																strategy[4][0] = s7;
																strategy[4][1] = s8;
																strategy[5][0] = s9;
																strategy[5][1] = s10;
																strategy[6][0] = s11;
																strategy[6][1] = s12;
																optstrat = strategy_check (c, 0, 
																													 0, p, questions, strategy);
																if (optstrat == true)
																	{
																	cout << "s1=" << s1 << endl;
																	cout << "s2=" << s2 << endl;
																	cout << "s3=" << s3 << endl;
																	cout << "s4=" << s4 << endl;
																	cout << "s5=" << s5 << endl;
																	cout << "s6=" << s6 << endl;
																	cout << "s7=" << s7 << endl;
																	cout << "s8=" << s8 << endl;
																	cout << "s9=" << s9 << endl;
																	cout << "s10=" << s10 << endl;
																	cout << "s11=" << s11 << endl;
																	cout << "s12=" << s12 << endl;
																	exit(1);
																	}
																}
														}
												}
										}
							}
									
						}
				cout << "No solution" << endl;
			break;
			case 5:
				// p=2, c=8, questions=8
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				vec1[0] = 0;
				vec1[1] = 1;
				lbound = 0;
				ubound = 7;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						{
						vec2[0] = s1;
						vec2[1] = s2;
						if (eqvec(p,vec2))
							continue;
						if (vec_smaller (p,vec1,vec2) == 0)	
							continue;
						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
								{
								vec3[0] = s3;
								vec3[1] = s4;
								if (eqvec(p,vec3))
									continue;
								if (vec_smaller (p,vec2,vec3) == 0)	
									continue;
								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										{
										vec4[0] = s5;
										vec4[1] = s6;
										if (eqvec(p,vec4))
											continue;
										if (vec_smaller (p,vec3,vec4) == 0)	
											continue;
										for (s7=lbound; s7<=ubound; s7++)
											for (s8=lbound; s8<=ubound; s8++)
												{
												vec5[0] = s7;
												vec5[1] = s8;
												if (eqvec(p,vec5))
													continue;
												if (vec_smaller (p,vec4,vec5) == 0)	
													continue;
												for (s9=lbound; s9<=ubound; s9++)
													for (s10=lbound; s10<=ubound; s10++)
														{
														vec6[0] = s9;
														vec6[1] = s10;
														if (eqvec(p,vec6))
															continue;
														if (vec_smaller (p,vec5,vec6) == 0)	
															continue;
														for (s11=lbound; s11<=ubound; s11++)
															for (s12=lbound; s12<=ubound; s12++)
																{
																vec7[0] = s11;
																vec7[1] = s12;
																if (eqvec(p,vec7))
																	continue;
																if (vec_smaller (p,vec6,vec7) == 0)	
																for (s13=lbound; s13<=ubound; s13++)
																	for (s14=lbound; s14<=ubound; s14++)
																		{
																		vec6[0] = s13;
																		vec6[1] = s14;
																		if (eqvec(p,vec8))
																			continue;
																		if (vec_smaller (p,vec7,vec8) == 0)	
																			continue;
																		strategy[1][0] = s1;
																		strategy[1][1] = s2;
																		strategy[2][0] = s3;
																		strategy[2][1] = s4;
																		strategy[3][0] = s5;
																		strategy[3][1] = s6;
																		strategy[4][0] = s7;
																		strategy[4][1] = s8;
																		strategy[5][0] = s9;
																		strategy[5][1] = s10;
																		strategy[6][0] = s11;
																		strategy[6][1] = s12;
																		strategy[7][0] = s13;
																		strategy[7][1] = s14;
																		optstrat = strategy_check (c, 0, 
																															 0, p, questions, strategy);
																		if (optstrat == true)
																			{
																			cout << "s1=" << s1 << endl;
																			cout << "s2=" << s2 << endl;
																			cout << "s3=" << s3 << endl;
																			cout << "s4=" << s4 << endl;
																			cout << "s5=" << s5 << endl;
																			cout << "s6=" << s6 << endl;
																			cout << "s7=" << s7 << endl;
																			cout << "s8=" << s8 << endl;
																			cout << "s9=" << s9 << endl;
																			cout << "s10=" << s10 << endl;
																			cout << "s11=" << s11 << endl;
																			cout << "s12=" << s12 << endl;
																			cout << "s13=" << s13 << endl;
																			cout << "s14=" << s14 << endl;
																			exit(1);
																	  }
																	}
																}
														}
												}
										}
							}
									
						}
				cout << "No solution" << endl;
			break;
			case 6:	
				// p=3, c=3, questions=3
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				strategy[0][2] = 2;
				vec1[0] = 0;
				vec1[1] = 1;
				vec1[2] = 2;
				lbound = 0;
				ubound = 2;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						for (s3=lbound; s3<=ubound; s3++)
							{
							vec2[0] = s1;
							vec2[1] = s2;
							vec2[2] = s3;
							if (eqvec(p,vec2))
								continue;
							if (vec_smaller (p,vec1,vec2) == 0)	
								continue;

							for (s4=lbound; s4<=ubound; s4++)
								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										{
										vec3[0] = s4;
										vec3[1] = s5;
										vec3[2] = s6;
										if (eqvec(p,vec3))
											continue;
										if (vec_smaller (p,vec2,vec3) == 0)	
											continue;
										strategy[1][0] = s1;
										strategy[1][1] = s2;
										strategy[1][2] = s3;
										strategy[2][0] = s4;
										strategy[2][1] = s5;
										strategy[2][2] = s6;
										optstrat = strategy_check (c, 0, 
																							 0, p, questions, strategy);
										if (optstrat == true)
											{
											cout << "s1=" << s1 << endl;
											cout << "s2=" << s2 << endl;
											cout << "s3=" << s3 << endl;
											cout << "s4=" << s4 << endl;
											cout << "s5=" << s5 << endl;
											cout << "s6=" << s6 << endl;
											exit(1);
											}
										}
							}
				cout << "No solution" << endl;
			break;
			case 7:	
				// p=3, c=4, questions=3
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				strategy[0][2] = 2;
				vec1[0] = 0;
				vec1[1] = 1;
				vec1[2] = 2;
				lbound = 0;
				ubound = 3;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						for (s3=lbound; s3<=ubound; s3++)
							{
							vec2[0] = s1;
							vec2[1] = s2;
							vec2[2] = s3;
							if (eqvec(p,vec2))
								continue;
							if (vec_smaller (p,vec1,vec2) == 0)	
								continue;

							for (s4=lbound; s4<=ubound; s4++)
								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										{
										vec3[0] = s4;
										vec3[1] = s5;
										vec3[2] = s6;
										if (eqvec(p,vec3))
											continue;
										if (vec_smaller (p,vec2,vec3) == 0)	
											continue;
										strategy[1][0] = s1;
										strategy[1][1] = s2;
										strategy[1][2] = s3;
										strategy[2][0] = s4;
										strategy[2][1] = s5;
										strategy[2][2] = s6;
										optstrat = strategy_check (c, 0, 
																							 0, p, questions, strategy);
										if (optstrat == true)
											{
											cout << "s1=" << s1 << endl;
											cout << "s2=" << s2 << endl;
											cout << "s3=" << s3 << endl;
											cout << "s4=" << s4 << endl;
											cout << "s5=" << s5 << endl;
											cout << "s6=" << s6 << endl;
											exit(1);
											}
										}
							}
				cout << "No solution" << endl;
			break;
			case 8:
				// p=3, c=5, questions=5
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				strategy[0][2] = 2;
				vec1[0] = 0;
				vec1[1] = 1;
				vec1[2] = 2;
				lbound = 0;
				ubound = 4;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						for (s3=lbound; s3<=ubound; s3++)
							{
							vec2[0] = s1;
							vec2[1] = s2;
							vec2[2] = s3;
							if (eqvec(p,vec2))
								continue;
							if (vec_smaller (p,vec1,vec2) == 0)	
								continue;
							for (s4=lbound; s4<=ubound; s4++)
								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										{
										vec3[0] = s4;
										vec3[1] = s5;
										vec3[2] = s6;
										if (eqvec(p,vec3))
											continue;
										if (vec_smaller (p,vec2,vec3) == 0)	
											continue;
										for (s7=lbound; s7<=ubound; s7++)
											for (s8=lbound; s8<=ubound; s8++)
												for (s9=lbound; s9<=ubound; s9++)
													{
													vec4[0] = s7;
													vec4[1] = s8;
													vec4[2] = s9;
													if (eqvec(p,vec4))
														continue;
													if (vec_smaller (p,vec3,vec4) == 0)	
														continue;
													for (s10=lbound; s10<=ubound; s10++)
														for (s11=lbound; s11<=ubound; s11++)
															for (s12=lbound; s12<=ubound; s12++)
																{
																vec5[0] = s10;
																vec5[1] = s11;
																vec5[2] = s12;
																if (eqvec(p,vec5))
																	continue;
																if (vec_smaller (p,vec4,vec5) == 0)	
																	continue;
																strategy[1][0] = s1;
																strategy[1][1] = s2;
																strategy[1][2] = s3;
																strategy[2][0] = s4;
																strategy[2][1] = s5;
																strategy[2][2] = s6;
																strategy[3][0] = s7;
																strategy[3][1] = s8;
																strategy[3][2] = s9;
																strategy[4][0] = s10;
																strategy[4][1] = s11;
																strategy[4][2] = s12;
																optstrat = strategy_check (c, 0, 
																													 0, p, questions, strategy);
																if (optstrat == true)
																	{
																	cout << "s1=" << s1 << endl;
																	cout << "s2=" << s2 << endl;
																	cout << "s3=" << s3 << endl;
																	cout << "s4=" << s4 << endl;
																	cout << "s5=" << s5 << endl;
																	cout << "s6=" << s6 << endl;
																	cout << "s7=" << s7 << endl;
																	cout << "s8=" << s8 << endl;
																	cout << "s9=" << s9 << endl;
																	cout << "s10=" << s10 << endl;
																	cout << "s11=" << s11 << endl;
																	cout << "s12=" << s12 << endl;
																	exit(1);
																	}
																}
														}
										}
							}
				cout << "No solution" << endl;
			break;
			case 9:	
				// p=4, c=4, questions=3
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				strategy[0][2] = 2;
				strategy[0][3] = 3;
				vec1[0] = 0;
				vec1[1] = 1;
				vec1[2] = 2;
				vec1[3] = 3;
				lbound = 0;
				ubound = 3;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
								{
								vec2[0] = s1;
								vec2[1] = s2;
								vec2[2] = s3;
								vec2[3] = s4;
								if (eqvec(p,vec2))
									continue;
								if (vec_smaller (p,vec1,vec2) == 0)	
									continue;

								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										for (s7=lbound; s7<=ubound; s7++)
											for (s8=lbound; s8<=ubound; s8++)
												{
												vec3[0] = s5;
												vec3[1] = s6;
												vec3[2] = s7;
												vec3[3] = s8;
												if (eqvec(p,vec3))
													continue;
												if (vec_smaller (p,vec2,vec3) == 0)	
													continue;
												strategy[1][0] = s1;
												strategy[1][1] = s2;
												strategy[1][2] = s3;
												strategy[1][3] = s4;
												strategy[2][0] = s5;
												strategy[2][1] = s6;
												strategy[2][2] = s7;
												strategy[2][3] = s8;
												optstrat = strategy_check (c, 0, 
																									 0, p, questions, strategy);
												if (optstrat == true)
													{
													cout << "s1=" << s1 << endl;
													cout << "s2=" << s2 << endl;
													cout << "s3=" << s3 << endl;
													cout << "s4=" << s4 << endl;
													cout << "s5=" << s5 << endl;
													cout << "s6=" << s6 << endl;
													cout << "s7=" << s7 << endl;
													cout << "s8=" << s8 << endl;
													exit(1);
													}
												}
								}
				cout << "No solution" << endl;
			break;
			case 10:	
				// p=4, c=5, questions=5
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				strategy[0][2] = 2;
				strategy[0][3] = 3;
				vec1[0] = 0;
				vec1[1] = 1;
				vec1[2] = 2;
				vec1[3] = 3;
				lbound = 0;
				ubound = 4;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
								{
								vec2[0] = s1;
								vec2[1] = s2;
								vec2[2] = s3;
								vec2[3] = s4;
								if (eqvec(p,vec2))
									continue;
								if (vec_smaller (p,vec1,vec2) == 0)	
									continue;
								for (s5=lbound; s5<=ubound; s5++)
									for (s6=lbound; s6<=ubound; s6++)
										for (s7=lbound; s7<=ubound; s7++)
											for (s8=lbound; s8<=ubound; s8++)
													{
													vec3[0] = s5;
													vec3[1] = s6;
													vec3[2] = s7;
													vec3[3] = s8;
													if (eqvec(p,vec3))
														continue;
													if (vec_smaller (p,vec2,vec3) == 0)	
														continue;
													for (s9=lbound; s9<=ubound; s9++)
														for (s10=lbound; s10<=ubound; s10++)
															for (s11=lbound; s11<=ubound; s11++)
																for (s12=lbound; s12<=ubound; s12++)
																	{
																	vec4[0] = s9;
																	vec4[1] = s10;
																	vec4[2] = s11;
																	vec4[3] = s12;
																	if (eqvec(p,vec4))
																		continue;
																	if (vec_smaller (p,vec3,vec4) == 0)	
																		continue;
																	for (s13=lbound; s13<=ubound; s13++)
																		for (s14=lbound; s14<=ubound; s14++)
																			for (s15=lbound; s15<=ubound; s15++)
																				for (s16=lbound; s16<=ubound; s16++)
																						{
																						vec5[0] = s13;
																						vec5[1] = s14;
																						vec5[2] = s15;
																						vec5[3] = s16;
																						if (eqvec(p,vec5))
																							continue;
																						if (vec_smaller(p,vec4,vec5) == 0)	
																							continue;
																						strategy[1][0] = s1;
																						strategy[1][1] = s2;
																						strategy[1][2] = s3;
																						strategy[1][3] = s4;
																						strategy[2][0] = s5;
																						strategy[2][1] = s6;
																						strategy[2][2] = s7;
																						strategy[2][3] = s8;
																						strategy[3][0] = s9;
																						strategy[3][1] = s10;
																						strategy[3][2] = s11;
																						strategy[3][3] = s12;
																						strategy[4][0] = s13;
																						strategy[4][1] = s14;
																						strategy[4][2] = s15;
																						strategy[4][3] = s16;
																						optstrat = strategy_check (c, 0, 
																																			 0, p, questions, strategy);
																						if (optstrat == true)
																							{
																							cout << "s1=" << s1 << endl;
																							cout << "s2=" << s2 << endl;
																							cout << "s3=" << s3 << endl;
																							cout << "s4=" << s4 << endl;
																							cout << "s5=" << s5 << endl;
																							cout << "s6=" << s6 << endl;
																							cout << "s7=" << s7 << endl;
																							cout << "s8=" << s8 << endl;
																							cout << "s9=" << s9 << endl;
																							cout << "s10=" << s10 << endl;
																							cout << "s11=" << s11 << endl;
																							cout << "s12=" << s12 << endl;
																							cout << "s13=" << s13 << endl;
																							cout << "s14=" << s14 << endl;
																							cout << "s15=" << s15 << endl;
																							cout << "s16=" << s16 << endl;
																							exit(1);
																							}

																						}
																	}
													}
								}
				cout << "No solution" << endl;
			break;
			case 11:	
			  // p=5, c=5, questions=5
				strategy[0][0] = 0;
				strategy[0][1] = 1;
				strategy[0][2] = 2;
				strategy[0][3] = 3;
				strategy[0][4] = 4;
				vec1[0] = 0;
				vec1[1] = 1;
				vec1[2] = 2;
				vec1[3] = 3;
				vec1[4] = 4;
				lbound = 0;
				ubound = 4;
				for (s1=lbound; s1<=ubound; s1++)
					for (s2=lbound; s2<=ubound; s2++)
						for (s3=lbound; s3<=ubound; s3++)
							for (s4=lbound; s4<=ubound; s4++)
								for (s5=lbound; s5<=ubound; s5++)
									{
									vec2[0] = s1;
									vec2[1] = s2;
									vec2[2] = s3;
									vec2[3] = s4;
									vec2[4] = s5;
									if (eqvec(p,vec2))
										continue;
									if (vec_smaller (p,vec1,vec2) == 0)	
										continue;
									for (s6=lbound; s6<=ubound; s6++)
										for (s7=lbound; s7<=ubound; s7++)
											for (s8=lbound; s8<=ubound; s8++)
												for (s9=lbound; s9<=ubound; s9++)
													for (s10=lbound; s10<=ubound; s10++)
													  {
														vec3[0] = s6;
														vec3[1] = s7;
														vec3[2] = s8;
														vec3[3] = s9;
														vec3[4] = s10;
														if (eqvec(p,vec3))
															continue;
														if (vec_smaller (p,vec2,vec3) == 0)	
															continue;
														for (s11=lbound; s11<=ubound; s11++)
															for (s12=lbound; s12<=ubound; s12++)
																for (s13=lbound; s13<=ubound; s13++)
																	for (s14=lbound; s14<=ubound; s14++)
																		for (s15=lbound; s15<=ubound; s15++)
																			{
																			vec4[0] = s11;
																			vec4[1] = s12;
																			vec4[2] = s13;
																			vec4[3] = s14;
																			vec4[4] = s15;
																			if (eqvec(p,vec4))
																				continue;
																			if (vec_smaller (p,vec3,vec4) == 0)	
																				continue;
																			for (s16=lbound; s16<=ubound; s16++)
																				for (s17=lbound; s17<=ubound; s17++)
																					for (s18=lbound; s18<=ubound; s18++)
																						for (s19=lbound; s19<=ubound; s19++)
																							for (s20=lbound; s20<=ubound; s20++)
																								{
																								vec5[0] = s16;
																								vec5[1] = s17;
																								vec5[2] = s18;
																								vec5[3] = s19;
																								vec5[4] = s20;
																								if (eqvec(p,vec5))
																									continue;
																								if (vec_smaller(p,vec4,vec5) == 0)	
																									continue;
																								strategy[1][0] = s1;
																								strategy[1][1] = s2;
																								strategy[1][2] = s3;
																								strategy[1][3] = s4;
																								strategy[1][4] = s5;
																								strategy[2][0] = s6;
																								strategy[2][1] = s7;
																								strategy[2][2] = s8;
																								strategy[2][3] = s9;
																								strategy[2][4] = s10;
																								strategy[3][0] = s11;
																								strategy[3][1] = s12;
																								strategy[3][2] = s13;
																								strategy[3][3] = s14;
																								strategy[3][4] = s15;
																								strategy[4][0] = s16;
																								strategy[4][1] = s17;
																								strategy[4][2] = s18;
																								strategy[4][3] = s19;
																								strategy[4][4] = s20;
																								optstrat = strategy_check (c, 0, 
																																					 0, p, questions, strategy);
																								if (optstrat == true)
																									{
																									cout << "s1=" << s1 << endl;
																									cout << "s2=" << s2 << endl;
																									cout << "s3=" << s3 << endl;
																									cout << "s4=" << s4 << endl;
																									cout << "s5=" << s5 << endl;
																									cout << "s6=" << s6 << endl;
																									cout << "s7=" << s7 << endl;
																									cout << "s8=" << s8 << endl;
																									cout << "s9=" << s9 << endl;
																									cout << "s10=" << s10 << endl;
																									cout << "s11=" << s11 << endl;
																									cout << "s12=" << s12 << endl;
																									cout << "s13=" << s13 << endl;
																									cout << "s14=" << s14 << endl;
																									cout << "s15=" << s15 << endl;
																									cout << "s16=" << s16 << endl;
																									cout << "s17=" << s17 << endl;
																									cout << "s18=" << s18 << endl;
																									cout << "s19=" << s19 << endl;
																									cout << "s20=" << s20 << endl;
																									exit(1);
																									}

																								}
																			}
													  }
									}
				cout << "No solution" << endl;
			break;
		  }
		}


  if (anzstrat != 1)
	  {
		cout << "Successes: " << successes << " of " << anzstrat << endl;
		}

  free (vec1);
  free (vec2);
  free (vec3);
  free (vec4);
  free (vec5);
  free (vec6);
  free (vec7);
  free (vec8);

  for (i=0; i<questions; i++)
	   free (strategy[i]);
	free (strategy);

	free (filename);

	return 1;
	}

